var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
import { action, makeObservable, observable } from "mobx";
let StateController = (() => {
    var _a;
    let _instanceExtraInitializers = [];
    let _state_decorators;
    let _state_initializers = [];
    let _state_extraInitializers = [];
    let _setState_decorators;
    let _resetState_decorators;
    return _a = class StateController {
            constructor(defaultState) {
                this.state = (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _state_initializers, {}));
                this.defaultState = __runInitializers(this, _state_extraInitializers);
                this.state = defaultState;
                this.defaultState = defaultState;
                makeObservable(this);
            }
            setState(state, value) {
                if (typeof state === "object") {
                    this.state = {
                        ...this.state,
                        ...state
                    };
                }
                else
                    this.state[String(state)] = value;
            }
            resetState(...keep) {
                const nextState = { ...this.defaultState };
                keep.forEach(keepKey => nextState[keepKey] = this.state[keepKey]);
                this.state = nextState;
            }
        },
        (() => {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
            _state_decorators = [observable];
            _setState_decorators = [action];
            _resetState_decorators = [action];
            __esDecorate(_a, null, _setState_decorators, { kind: "method", name: "setState", static: false, private: false, access: { has: obj => "setState" in obj, get: obj => obj.setState }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(_a, null, _resetState_decorators, { kind: "method", name: "resetState", static: false, private: false, access: { has: obj => "resetState" in obj, get: obj => obj.resetState }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(null, null, _state_decorators, { kind: "field", name: "state", static: false, private: false, access: { has: obj => "state" in obj, get: obj => obj.state, set: (obj, value) => { obj.state = value; } }, metadata: _metadata }, _state_initializers, _state_extraInitializers);
            if (_metadata) Object.defineProperty(_a, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        })(),
        _a;
})();
/**
 * Base module with state only.
 */
export default StateController;
